#include <stdint.h>
#include "usb.h"
#include "atmega8.h"
#include "../firmware/usbi2c.h"

static int portop(int reg, int bit, int V)
{
  int op;
  int r;
  if (bit<0 || bit>7) return ;
  if (reg<0 || reg>5) return ;
  if (V<0   || V>1)   return ;
  op= V*48 + reg*8 + bit;

  r= usb_simple(PORTOP, op, 0);
  if (r<0) { print_libusb_error("PORT", r); return 1; }
  return 0;
}

static int pinop(int reg)
{
  uint8_t data[1];
  int r;
  if (reg<0 || reg>2) return -1;
  r= usb_read(PINOP, reg, 0, data, 1);
  if (r<0) { print_libusb_error("PORT", r); return -1; }
  return data[0];
}

int atmega8_portB(int bit,int V) { return portop(0, bit, V); }
int atmega8_ddrB(int bit,int V)  { return portop(1, bit, V); }
int atmega8_portC(int bit,int V) { return portop(2, bit, V); }
int atmega8_ddrC(int bit,int V)  { return portop(3, bit, V); }
int atmega8_portD(int bit,int V) { return portop(4, bit, V); }
int atmega8_ddrD(int bit,int V)  { return portop(5, bit, V); }

int atmega8_pinB() { return pinop(0); }
int atmega8_pinC() { return pinop(1); }
int atmega8_pinD() { return pinop(2); }

