#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gfx.h"
#include "func.h"

#define DISP_W 480
#define DISP_H 800

#define BUT_W 120
#define BUT_H 30
#define PAD  10
#define TEXTW 70

enum { WI_ITsel= GFXEV_LAST+1, WI_IText, WI_ITrad, 
       WI_OTspk,  WI_OThea, WI_OTblu, WI_RADEC, WI_RAINC };

static int rade;

static int toggle(char *str, int action, int *x, int y)
{
  int R;
  R= gfx_toggle_button(*x,y,BUT_W,BUT_H, 0,0,str, action);
  gfx_show(R,1);
  *x+= PAD+BUT_W;
  return R;
}

static void toggle3(int ON,int OFF1,int OFF2)
{
  gfx_toggle_button_set(ON,1);
  gfx_toggle_button_set(OFF1,0);
  gfx_toggle_button_set(OFF2,0);
}

static int fou[4];

static int setfou(int K)
{
  int i;
  for(i=0;i<4;i++) { fou[3-i]= K%10; K/= 10; }
}

static int getfou()
{
  int i;
  int V= 0;
  for(i=0;i<4;i++) { V= V*10+fou[i]; }
  return V;
}


static void freqset(int delta)
{
  int V;
  char B[10];
  char *C;

  V= getfou() + delta;
  if (V>1080) V= 1080;
  else if (V<875) V= 875;

  if (V!=getfou()) setfou(V);

  sprintf(B,"%d",V/10);
  C= B+strlen(B);
  sprintf(C,".%d",V%10); 
  gfx_text_entry_set(GFX_UPDATE, rade, B);
  tea5767_setfreq(V/10.0);
}

int main()
{
  int x,y;
  int tb_itsel, tb_itext, tb_itrad, tb_otspk, tb_othea, tb_otblu;

  switch_init();

  gfx_init(NULL,DISP_W,DISP_H,"Audio Switch");
  gfx_fill_rect(0,0,0,DISP_W,DISP_H, 0xededed); 
  
  x= PAD;
  y= PAD;
  gfx_print(0,1, 0x00, 0xededed, x,y, "Input", NULL, NULL);
  x+= TEXTW+PAD;
  tb_itsel= toggle("Computer", WI_ITsel,&x,y);
  tb_itext= toggle("Line In",  WI_IText,&x,y);
  tb_itrad= toggle("Radio",    WI_ITrad,&x,y);

  x= PAD;
  y+= BUT_H+PAD;
  gfx_print(0,1, 0x00, 0xededed, x,y, "Output", NULL, NULL);
  x+= TEXTW+PAD;
  tb_otspk= toggle("Speakers",   WI_OTspk,&x,y);
  tb_othea= toggle("Headphones", WI_OThea,&x,y);
  tb_otblu= toggle("Bluetooth",  WI_OTblu,&x,y);

  y+= BUT_H+PAD;
  x=PAD;
  gfx_print(0,1, 0x00, 0xededed, x,y, "Radio", NULL, NULL);
  x+= BUT_W+PAD;
  gfx_button(0, x,y, 30, BUT_H, "-", WI_RADEC);
  x+= 30+PAD;
  rade= gfx_text_entry(x,y,80,BUT_H,"100.0");
  setfou(1000);
  gfx_show(rade,1);
  x+= 80+PAD;
  gfx_button(0,x,y, 30, BUT_H, "+", WI_RAINC);


  gfx_toggle_button_set(tb_itsel,1);
  gfx_toggle_button_set(tb_otspk,1);

  gfx_update_all();

  while(1)
  {
  gfx_event_t event;
  if (!gfx_event(NULL,&event)) continue;
  switch(event.type)
  {
case WI_ITsel: select_input(0);  toggle3(tb_itsel,tb_itext,tb_itrad);break;
case WI_IText: select_input(2);  toggle3(tb_itext,tb_itrad,tb_itsel);break;
case WI_ITrad: select_input(1);  toggle3(tb_itrad,tb_itsel,tb_itext);break;

case WI_OTspk: select_output(0); toggle3(tb_otspk,tb_othea,tb_otblu);break;
case WI_OThea: select_output(2); toggle3(tb_othea,tb_otblu,tb_otspk);break; 
case WI_OTblu: select_output(1); toggle3(tb_otblu,tb_otspk,tb_othea);break;

case WI_RADEC: freqset(-1); break;
case WI_RAINC: freqset(+1); break;
case GFXEV_QUIT: goto done;
  }
  }
done:
  usb_exit(0);
}
