#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include "../firmware/usbi2c.h"
#include "usb.h"
#include "tea5767.h"

uint8_t data[5];

int main(int argc,char **argv)
{
  int i,r;
  usb_init();
  usb_open();

  tea5767_Wdefaults(data);

  tea5767_Wsnc(data,0);

  if (argc>1)
  {
    tea5767_Wpll(data, tea5767_freq2pll( strtod(argv[1],NULL) ));
  }

  r= usb_write(I2C_fill, 0,0, data, 5);
  if (r<0) exit_print_libusb_error("FILL:", r);
  r= usb_read(I2C_write, TEA5767_I2C_ADDR, 0, data, 1);
  if (r<0) exit_print_libusb_error("WRITE:", r);
  if (data[0]&I2C_error) exit(fprintf(stderr,"I2C error during write\n"));

  for(i=0;i<5;i++)
  {
    usleep(1e4);

    r= usb_read(I2C_read, TEA5767_I2C_ADDR, 5, data, 1);
    if (r<0) exit_print_libusb_error("READ:", r);
    if (data[0]&I2C_error) exit(fprintf(stderr,"I2C error during read\n"));

    r= usb_read(I2C_get, 0, 5, data, 5);
    if (r<0) exit_print_libusb_error("GET:", r);

    if (tea5767_Rrf(data)) break;
  }
  if (tea5767_Rrf(data)) 
  {
    printf("ready with pll= %x\n", tea5767_Rpll(data));
  }
  else
  {
    printf("not ready on time\n");
  }

  usb_exit(0);
  return 0;
}

