typedef struct
      {
  int   type;
  int   x, y;
  int   modifiers;
  int   button;
  int   key;
  char *string;
  void *usr;
  int wide;
  double flo0, flo1;
      }
    gfx_event_t;

enum
{
  GFXEV_BUTTON_PRESS=1, GFXEV_BUTTON_RELEASE,
  GFXEV_KEY_PRESS,      GFXEV_KEY_RELEASE,
  GFXEV_POINTER_MOVE,   
  GFXEV_READY_READ, GFXEV_READY_WRITE, GFXEV_READY_EXCEPT,
  GFXEV_QUIT, GFXEV_LAST,
};

/* The event routine returns an event from the queue. It waits a maximum
   of 'msecs' milliseconds for the event. If msecs is zero, it waits
   until an event is received.

   The return value is one if an event is returned. It's zero if the
   return was due to timeout.

   In case of an event, *msecs is updated to reflect the remaining
   wait time.  */

int gfx_event(unsigned int *msecs,gfx_event_t *Revent);

enum
{ 
   GFX_K_PRT=1, 
   GFX_K_BACKSPACE,     GFX_K_TAB,      GFX_K_RETURN, GFX_K_ESCAPE,
   GFX_K_INSERT,        GFX_K_DELETE,   GFX_K_HOME,   GFX_K_END,
   GFX_K_PAGEUP,        GFX_K_PAGEDOWN,
   GFX_K_LEFT,          GFX_K_RIGHT,    GFX_K_DOWN,   GFX_K_UP,
   GFX_K_CONTROL=0x100, GFX_K_SHIFT= 0x200 , GFX_K_ALT= 0x400,
};

int gfx_init(char *name, int width, int height, char *title);
void gfx_close();


void gfx_geometry(unsigned int *W, unsigned int *H);
void gfx_monitor_file(int fd, int ident, int R,int W,int X);
void gfx_stop_monitor_file(int fd,int ident);
void gfx_leave_screen();
void gfx_set_state(int wno, int state);
int  gfx_get_state(int wno);
int  gfx_get_selected(int wno);
void gfx_set_selected(int wno,int sel);
void gfx_set_text(int wno,char *str);
void gfx_set_fgbg(int wno, int fg, int bg);
void gfx_insert(int wno,int pos, char *text,void *user,unsigned int* icon);
void gfx_remove(int wno, int pos, void **Ruser);
void gfx_focus(int wno);
 
   
int gfx_event(unsigned int *msecs,gfx_event_t *Revent);
enum { _XX_WIDGETS_START=GFXEV_LAST,
  /* WIDGET NAMES BELOW */
  MAIN_PANEL,
  Wheadphones,
  Wbluetooth,
  Wspeaker,
  LABEL_MID,
  Wexternal,
  Wradio,
  Wplayer,
  LABEL_TOP,
  Wfreqmore,
  Wfreqless,
  Wfreq,
  PLpagedown,
  PLpageup,
  Wplayertoppanel,
  PLdown,
  PLmiddle,
  PLup,
  PLlab13,
  PLlab12,
  PLlab11,
  PLlab10,
  PLlab9,
  PLlab8,
  PLlab7,
  PLlab6,
  PLlab5,
  PLlab4,
  PLlab3,
  PLlab2,
  PLlab1,
  Wjump,
  Wfiles,
  Wnexttrack,
  Wpause,
  Wplay,
  Wprevtrack,
  Wclear,
  Wplaylist,
  Whome,
  Wdirup,
  Waddlist,
  Wdirlist,

 _XX_WIDGETS_END };
void gfx_main_screen();
