#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "../firmware/usbled.h"
#include "usb.h"

static void usage(char **argv)
{
  fprintf(stderr,"usage: %s LED (0|1)\n where LED is 1 or 2\n", argv[0]);
  exit(1);
}

int main(int argc,char **argv)
{
  int led,cmd,val,r;
  char data[8];
  if (argc!=3) usage(argv);
  led= atoi(argv[1]);
  val= atoi(argv[2]);
  if (led<=0 || led>2) usage(argv);
  if (val<0 || val>1) usage(argv);
  usb_init();
  usb_open();
 
  cmd= (led==1) ? CMD_LED1 : CMD_LED2;
  r= usb_simple(cmd, val, 0);
  if (r<0) exit_print_libusb_error("SET LED", r);
  r= usb_read(CMD_STATUS, 0,0, data, 1);
  if (r<0) exit_print_libusb_error("GET LED", r);
  printf("LEDS: %d\n", data[0]);
  usb_exit(0);
  return 0;
}

